import { world, system, ItemStack, GameMode, EquipmentSlot } from '@minecraft/server';
import { breakableItems } from 'common/configs/breakable_items.js';

//entity-damage-item
export function damageItem(e, d, i){
	var dur = i.getComponent('minecraft:durability');
	var u = 0;
	if(i.hasComponent('enchantments')){
		u = i.getComponent('enchantments').enchantments.getEnchantment('unbreaking');
		if(!u){ u = 0 }
		else{ u = u.level }
	}
	if(u > 0){
		if(Math.random() * u < u / (u + 1) ? true : false){
			dur.damage += Math.round(d / u);
		}
	}
	else{
		try{
			dur.damage += d;
		}
		catch{
			dur.damage = dur.maxDurability;
		}
	}
	if(world.getPlayers({
		gameMode: GameMode.creative
	}).includes(e)) return
	if(dur.damage == dur.maxDurability){
		breakItem(e);
	}
	else{
		e.getComponent('minecraft:equippable').setEquipment(EquipmentSlot.Mainhand, i);
	}
}

world.afterEvents.playerBreakBlock.subscribe(e =>{
	let player = e.player;
	let item = e.itemStackBeforeBreak;
	updateDurabilityWhenBreakingBlock(player, item);
});

function updateDurabilityWhenBreakingBlock(e, i){
	if(i == undefined) return;
	if(!breakableItems.includes(i.typeId)) return;
	let dmgItem = damageItem(e, 1, i);
}

function breakItem(e){
	world.playSound('random.break', e.location);
	e.runCommand('replaceitem entity @s slot.weapon.mainhand 0 air');
}