import { world, system, ItemStack, EquipmentSlot } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(e =>{
	e.itemComponentRegistry.registerCustomComponent('raigen:on_use_on', {
		onUseOn(i){
			let { blockFace, block, itemStack, source } = i;
			useBlueprints(blockFace, block, itemStack, source);
		}
	});
});

function useBlueprints(f, b, i, s){
	let xMod = 0, yMod = 0, zMod = 0;
	f == 'North' ? zMod = -1 : null;
	f == 'South' ? zMod = 1 : null;
	f == 'West' ? xMod = -1 : null;
	f == 'East' ? xMod = 1 : null;
	f == 'Down' ? yMod = -1 : null;
	f == 'Up' ? yMod = 1 : null;
	if(i.typeId != 'raigen:blueprints') return;
	if(!s.isSneaking){
		if(i.getLore().length == 0){
			i.setLore([`From: ${b.x + xMod} ${b.y + yMod} ${b.z + zMod}`]);
			s.getComponent('equippable').setEquipment(EquipmentSlot.Mainhand, i);
			s.runCommand(`title @s actionbar §d${i.getLore()[0]}`);
			let hologram = s.dimension.spawnEntity('raigen:blueprints_hologram', {x:b.location.x + 0.5 + xMod, y:b.location.y + yMod, z:b.location.z + 0.5 + zMod});
			hologram.triggerEvent('raigen:event_from');
		}
		else if(i.getLore().length == 1){
			i.setLore([i.getLore()[0], `To: ${b.x + xMod} ${b.y + yMod} ${b.z + zMod}`]);
			s.getComponent('equippable').setEquipment(EquipmentSlot.Mainhand, i);
			s.runCommand(`title @s actionbar §d${i.getLore()[1]}`);
			let hologram = s.dimension.spawnEntity('raigen:blueprints_hologram', {x:b.location.x + 0.5 + xMod, y:b.location.y + yMod, z:b.location.z + 0.5 + zMod});
			let fC = i.getLore()[0].split(' ');
			let tC = i.getLore()[1].split(' ');
			hologram.setDynamicProperty('raigen:from_coords', {x:parseInt(fC[1]), y:parseInt(fC[2]), z:parseInt(fC[3])});
			hologram.setDynamicProperty('raigen:to_coords', {x:parseInt(tC[1]), y:parseInt(tC[2]), z:parseInt(tC[3])});
			hologram.triggerEvent('raigen:event_to');
		}
		else if(i.getLore().length == 2){
			let hologram = s.dimension.spawnEntity('raigen:blueprints_hologram', {x:b.location.x + 0.5 + xMod, y:b.location.y + yMod, z:b.location.z + 0.5 + zMod});
			let fC = i.getLore()[0].split(' ');
			let tC = i.getLore()[1].split(' ');
			hologram.setDynamicProperty('raigen:from_coords', {x:parseInt(fC[1]), y:parseInt(fC[2]), z:parseInt(fC[3])});
			hologram.setDynamicProperty('raigen:to_coords', {x:parseInt(tC[1]), y:parseInt(tC[2]), z:parseInt(tC[3])});
			hologram.triggerEvent('raigen:event_to');
		}
	}
	else{
		s.runCommand(`title @s actionbar §cCoordinates Erased!`);
		i.setLore([]);
		s.getComponent('equippable').setEquipment(EquipmentSlot.Mainhand, i);
	}
}

function setHologram(f, b, i, s){
}